Added comment to the mp4 encoding profiles to indicate they aren't working yet.
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index 1b3fec5840f85005ce9650404c89da00be0eed56..ed395b2e409c17d44393bbdd0e25d479519fc4a1 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -40,6 +40,7 @@ config="${0%/*}/rip_dvd.conf"
 ##############################################################################################
 # Command line processing
 ##############################################################################################
+typeset cmd="$0 $*"
 typeset dvdname=""
 typeset debug=""
 typeset dest=""
@@ -49,8 +50,10 @@ typeset dvdpath=""
 typeset aspect=""
 typeset SCALE=""
 typeset CROP=""
-typeset profile="xvid"
+typeset profile="xvidvhq"
 typeset extension=""
+typeset -i force_onepass_mode=0
+typeset -i eject_disk=1
 typeset -i keep_isofile=0
 typeset -i keep_vobfile=0
 typeset -i keep_dvdfolder=0
@@ -62,14 +65,14 @@ typeset -i make_final_dest_comp=0
 typeset -i errors=0
 typeset -i show_usage=0
 typeset -i mirror_mode=0
-typeset -i target_bitrate=0
+typeset -i target_bitrate=2000
 typeset -i target_size=0
 typeset -i audio_2ch=0
 typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
 
-while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
+while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
@@ -77,6 +80,7 @@ do
         (b)     target_bitrate=$OPTARG;;
        (s)     target_size=$OPTARG;;
         (2)     audio_2ch=1;;
+        (1)     force_onepass_mode=1;;
         (v)     make_final_dest_vob=1;;
         (i)     make_final_dest_iso=1;;
         (f)     make_final_dest_folder=1;; 
@@ -87,6 +91,7 @@ do
        (a)     aspect=$OPTARG;;
        (p)     profile=$OPTARG;;
        (e)     extension=$OPTARG;;
+       (j)     eject_disk=$OPTARG;;
         (w)     set -$opt;;
         (h)     show_usage=1;;
         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
@@ -108,12 +113,14 @@ function usage() {
     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
-    echo >&2 "                 - xvid = AVI, Xvid codec, 2 pass encoding, original aspect, no scaling (default)"
-    echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
-    echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
-    echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
-    echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, 480:320 scaling"
-    echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, 320:240 scaling"
+    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
+    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
+    #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
+    #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
+    #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
+    echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
@@ -129,6 +136,12 @@ function usage() {
     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
+    echo >&2 "   -j <n>        Eject the disk:"
+    echo >&2 "                 - 0 = do not eject the disk"
+    echo >&2 "                 - 1 = eject after the entire script is done (default)"
+    echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
+    echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
+    echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
@@ -150,8 +163,8 @@ if [ "$dest" == "" ]; then
   usage
 fi
 
-if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
-  echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
+if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
+  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
   usage
 fi
 
@@ -248,7 +261,7 @@ else
 
     # check to see if dvdname is a full path to an ISO file
     # if it is, set dvdname and isofile appropriately
-    file "$dvdname" | grep -q "ISO"
+    file "$dvdname" | grep -q -e "ISO" -e "UDF"
     if [ $? == 0 ]; then
       # It is a valid ISO file, now strip the extension off our dvdname
       isofile="$dvdname"
@@ -265,6 +278,8 @@ else
     fi
   fi
   ripdvd=0
+  # Since we aren't ripping a DVD disk, don't eject anything
+  eject_disk=0
 fi
 
 # remove bad characters from the dvdname
@@ -341,6 +356,7 @@ fatal_and_exit() {
   if [[ -n "$mailto" ]]; then
     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
   fi
+  keep_intermediate_files=1
   exit 1
 }
 
@@ -354,23 +370,65 @@ trap cleanup EXIT
 
 # encode the vob file into a compressed file format
 function encode_vob_file {
+
+  # Set a variable that we will use later to determine if we found a handler for $profile or not
   typeset -i found_profile=0
-   
+
+  # For a given profile, to override the 2 pass behavior to be single pass,
+  # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
+  # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+  PASSES="1 2"
+
+  # Declare our default 2 pass variables
+  passlogfile_opt="-passlogfile $passlogfile"
+  pass_opt="pass=%PASS"
+
+  # Check the global force_onepass_mode. If it is set, change our variables appropriately
+  # to force 1-pass encoding across all profiles.
+  if [ $force_onepass_mode -eq 1 ]; then
+    PASSES="2"
+    passlogfile_opt=""
+    pass_opt=""    
+  fi
+
   # XVID profile
-  if [ "$profile" == "xvid" ]; then
+  if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
     found_profile=1
     final_output_file="$dest/$dvdname.avi"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
-    mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
-    video_encoder_opts[1]="threads=$mencoder_threads"
-    video_encoder_opts[2]="chroma_opt"
-    video_encoder_opts[3]="vhq=4"
-    video_encoder_opts[4]="bvhq=1"
-    video_encoder_opts[5]="quant_type=mpeg"
-    video_encoder_opts[6]="autoaspect"
+    mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
+
+    # Very High Quality (16fps)
+    if [ "$profile" == "xvidvhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="chroma_opt"
+      video_encoder_opts[3]="vhq=4"
+      video_encoder_opts[4]="bvhq=1"
+      video_encoder_opts[5]="quant_type=mpeg"
+      video_encoder_opts[6]="autoaspect"
+    fi
+    # High Quality (20fps)
+    if [ "$profile" == "xvidhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="chroma_opt"
+      video_encoder_opts[3]="vhq=2"
+      video_encoder_opts[4]="bvhq=1"
+      video_encoder_opts[5]="quant_type=mpeg"
+      video_encoder_opts[6]="autoaspect"
+    fi
+    # Fast (28fps)
+    if [ "$profile" == "xvid" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="vhq=0"
+      video_encoder_opts[3]="turbo"
+      video_encoder_opts[4]="autoaspect"
+    fi
+
     for OPTS in "${video_encoder_opts[@]}"; do 
       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
     done
@@ -391,13 +449,14 @@ function encode_vob_file {
   fi
 
   # MP4 encoding profiles
+  # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
     found_profile=1
     final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
-    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
 
     # Very High Quality (6fps)
     if [ "$profile" == "mp4vhq" ]; then
@@ -473,10 +532,10 @@ function encode_vob_file {
       SCALE=",dsize=320:240:0,scale=-8:-8"
     fi
     final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
-    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
     video_encoder_opts[0]="bitrate=$target_bitrate"
     video_encoder_opts[1]="threads=$mencoder_threads"
     video_encoder_opts[2]="vbv_maxrate=1500"
@@ -506,7 +565,7 @@ function encode_vob_file {
   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
   mencoder_retval=0
 
-  for PASS in 1 2 
+  for PASS in $PASSES
   do 
     # Set some options based on which pass we are in
     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
@@ -534,7 +593,7 @@ function encode_vob_file {
     fi
 
     # Concatenate the encode log to our main log file, greping out unwanted lines
-    cat $encodelog | grep -v "Pos:" >> "$logfile"
+    cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
 
   done
 }
@@ -731,7 +790,8 @@ function get_crop_from_iso {
   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
   if [ -z "$CROP" ]; then
-    fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
+    echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
+    return
   fi
   if [ $CROPCHECK -lt 0 ]; then 
     CROP=""
@@ -755,7 +815,8 @@ function get_crop_from_vob {
   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
   if [ -z "$CROP" ]; then
-    fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
+    echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
+    return
   fi
   if [ $CROPCHECK -lt 0 ]; then 
     CROP=""
@@ -1055,6 +1116,7 @@ function remove_intermediate_dvdbackup_folder {
 # Make a note of when this DVD rip started
 date=`date`
 echo -e "\n$date DVD rip started" >> "$logfile"
+echo "$cmd" >> "$logfile"
 
 # Rip the DVD - Mirror Mode
 if [ $mirror_mode -eq 1 ]; then
@@ -1067,7 +1129,9 @@ if [ $mirror_mode -eq 1 ]; then
   fill_mythvideo_metadata "$dest/$dvdname.iso" 
 
   # eject the disk upon completion
-  eject -T $dev
+  if [ $eject_disk -ne 0 ]; then
+    eject -T $dev
+  fi
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"
@@ -1170,6 +1234,9 @@ if [ $mirror_mode -eq 0 ]; then
       get_crop_from_vob
     fi
 
+    # eject the DVD disk since we are finished with it
+    [ $eject_disk -eq 2 ] && eject -T $dev
+
     # encode the VOB file to a compressed file format
     if [ $make_final_dest_comp -eq 1 ]; then
       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
@@ -1249,7 +1316,7 @@ if [ $mirror_mode -eq 0 ]; then
   remove_intermediate_dvdbackup_folder
 
   # eject the DVD disk upon completion
-  [ $ripdvd -eq 1 ] && eject -T $dev
+  [ $eject_disk -eq 1 ] && eject -T $dev
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"